AddMoneyEvent = {}
AddMoneyEvent_mt = Class(AddMoneyEvent, Event)

InitEventClass(AddMoneyEvent, "AddMoneyEvent")

AddMoneyEvent.emptyNew = function (self)
	local self = Event:new(AddMoneyEvent_mt)

	return self
end
AddMoneyEvent.new = function (self, amount, statType)
	local self = AddMoneyEvent:emptyNew()
	self.amount = amount
	self.statType = statType

	return self
end
AddMoneyEvent.readStream = function (self, streamId, connection)
	self.amount = streamReadFloat32(streamId)
	local statTypeIndex = streamReadUInt8(streamId)
	self.statType = FinanceStats.statNames[statTypeIndex]

	self.run(self, connection)

	return 
end
AddMoneyEvent.writeStream = function (self, streamId, connection)
	streamWriteFloat32(streamId, self.amount)

	local statTypeIndex = nil

	if self.statType ~= nil then
		statTypeIndex = FinanceStats.statNameToIndex[self.statType]
	end

	if statTypeIndex == nil then
		statTypeIndex = 0
	end

	streamWriteUInt8(streamId, statTypeIndex)

	return 
end
AddMoneyEvent.run = function (self, connection)
	if not connection.getIsServer(connection) then
		local userId = g_currentMission:findUserIdByConnection(connection)
		g_currentMission:addMoney(self.amount, userId, self.statType)
	else
		print("Error: AddMoneyEvent is a client to server only event")
	end

	return 
end

return 
